﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using OA.Spatial.Example1.Model;
using Telerik.Windows.Controls.Map;
using Microsoft.SqlServer.Types;

namespace OA.Spatial.Example1.WPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            LoadData();
        }

        /// <summary>
        /// LoadData Method
        /// </summary>
        /// <returns>A void</returns>
        private void LoadData()
        {
          
        }

        public ExtendedData FillExtendedData(StateCounty info)
        {
            var propertySet = new ExtendedPropertySet();
            propertySet.RegisterProperty("Name", "Name", typeof(string), string.Empty);
            propertySet.RegisterProperty("Fips", "Fips", typeof(string), string.Empty);

            ExtendedData extendedData = new ExtendedData(propertySet);
            extendedData.SetValue("Name", info.NAME);
            extendedData.SetValue("Fips", info.CNTY_FIPS);
            return extendedData;
        }

        public ExtendedData FillExtendedData(OA.Spatial.Example1.Model.Location info)
        {
            var propertySet = new ExtendedPropertySet();
            propertySet.RegisterProperty("Area", "Area", typeof(string), string.Empty);

            ExtendedData extendedData = new ExtendedData(propertySet);
            extendedData.SetValue("Area", info.Area);
            return extendedData;
        }


        private void RadMenuItem_Click(object sender, Telerik.Windows.RadRoutedEventArgs e)
        {
            this.InformationLayer.Items.OfType<MapShape>().ToList().ForEach(this.InformationLayer.Items.Remove);
            using (var context = new TestDBEntityDiagrams())
            {
                this.InformationLayer.LoadSpatial(context.StateCounties.ToList(),
                                                  (stateCounty) => stateCounty.Geometry,
                                                  FillExtendedData);
            }
        }

        private void RadMenuItem_Click_1(object sender, Telerik.Windows.RadRoutedEventArgs e)
        {
            this.InformationLayer.Items.OfType<MapShape>().ToList().ForEach(this.InformationLayer.Items.Remove);
            using (var context = new TestDBEntityDiagrams())
            {
                this.InformationLayer.LoadSpatial(context.Locations.ToList(),
                                                  (location) => location.GeoLocation,
                                                  FillExtendedData);
            }
        }
    }
}
